-- Part of SmallEiffel -- Read DISCLAIMER file -- Copyright (C) 
-- Dominique COLNET and Suzanne COLLIN -- colnet@loria.fr
--
class STD_ERROR
--
-- To write on the standard error output. As for UNIX, the default standard 
-- error file is the screen.
--
-- Note: only one instance of this class should be necessary (have a look
-- in the root classes to search for the good name to use).
-- 
   
inherit 
   STD_FILE_WRITE 
      redefine disconnect 
      end;
   
creation 
   make, connect_to
   
feature {ANY}
   
   make is
      do
	 output_stream := stderr;
      ensure
	 not is_connected
      end;
   
   disconnect is
      local
	 err: INTEGER;
      do
	 err := fclose(output_stream); 
	 path := Void;
	 output_stream := stderr;
      end;
      
feature {NONE}   
   
   stderr: POINTER is
      external "CSE"
      end;

end -- class STD_ERROR
